Subject: bug#54331: 27.2; Closing frames loaded from desktop-read

From: Eli Zaretskii <[email-masked]>
Date: Thu, 10 Mar 2022 22:09:40 +0200

> From: Rehan Deen <[email-masked]>
> Date: Fri, 11 Mar 2022 00:13:23 +0530
> 
> A very annoying issue with `desktop-save` and `desktop-read` that I'm encountering at the moment:
> 
> - I'm starting Emacs in `daemon-mode`, and then open a client frame via
>   my WM shortcut for `emacsclient -c`. I do `desktop-read` and my saved desktop opens with the 10 or so frames I had saved.
> 
> - When I go to one of the frames with a buffer I'm no longer interested in, and do `C-x C-c`, I end up not just closing that particular frame, but **all 10 or so of the frames that were open**.
> 
> - The Emacs daemon is still running, and opening another client frame shows that the buffers haven't been killed, so nothing has been lost per se - it's just that the arrangement of all the frames I had is just ruined.
> 
> Any idea how to stop this behaviour (i.e. being able to just kill one frame from the saved configuration)? 

Is this really related to desktop-read?  AFAIK, "C-x C-c" deletes all
the frames displayed on the terminal, and I see the same behavior if I
start a daemon, invoke emacsclient to open a frame, and then make
several other frames from the same session.  "C-x C-c" then closes all
the frames I made.

I think this is the expected behavior.  What am I missing?